Codeforces Round #352 (Div. 1) B. Robin Hood(想法+二分,好题)

B. Robin Hood
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people. 

After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too. 

Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn't affect the answer.

Input

The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

Output

Print a single line containing the difference between richest and poorest peoples wealth.

Examples
input
4 1
1 1 4 2
output
2
input
3 1
2 2 2
output
0
Note

Lets look at how wealth changes through day in the first sample.

  1. [1, 1, 4, 2]
  2. [2, 1, 3, 2] or [1, 2, 3, 2]

So the answer is 3 - 1 = 2

In second sample wealth will remain the same for each person.



题意:

n个人,每个人ci的金币,每天最富有的人都会给最贫穷的人1金币,问k天后最富有人和最贫穷的人差了多少金币。

1 <= n <= 5e5, 0 <= k <= 1e9, 1 <= ci <= 1e9。


题解:

不妨把穷人和富人放在两个时空中
step1: 假设富人不用掏钱,每天给最穷的人1枚金币。
求出最穷的人金币数:x
step2: 假设穷人得不到钱,每天富人有1枚金币不翼而飞。
求出最富的人金币数: y
其中,x与y的值通过二分答案求解。

若x<y,那么答案为y-x.
如果x>=y, 若sum%n=0,辣么可以平分,答案为0,否则答案为1。


#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<vector>
#include<queue>
#include<stack>
using namespace std;
#define rep(i,a,n) for (int i=a;i<n;i++)
#define per(i,a,n) for (int i=n-1;i>=a;i--)
#define pb push_back
#define fi first
#define se second
typedef vector<int> VI;
typedef long long ll;
typedef pair<int,int> PII;
const int inf=0x3fffffff;
const ll mod=1000000007;
const int maxn=5e5+100;
ll c[maxn];
int n;
ll k;
bool check(ll x)
{
    ll sum=0;
    rep(i,1,n+1)
    {
        if(c[i]<=x) sum+=x-c[i];
        else
        {
            break;
        }
    }
    return sum<=k;
}

bool check1(ll x)
{
    ll sum=0;
    per(i,1,n+1)
    {
        if(c[i]>=x) sum+=c[i]-x;
        else
        {
            break;
        }
    }
    return sum<=k;
}

int main()
{
    ll sum=0;
    scanf("%d%lld",&n,&k);
    rep(i,1,n+1) scanf("%lld",&c[i]),sum=(sum+c[i])%n;
    sort(c+1,c+n+1);
    ll l=0,r=2e9,ans=0;
    while(l<=r)
    {
        ll m=(l+r)/2;
        if(check(m)) ans=m,l=m+1;
        else r=m-1;
    }
    l=0,r=1e9;
    ll ans1=0;
    while(l<=r)
    {
        ll m=(l+r)/2;
        if(check1(m)) ans1=m,r=m-1;
        else l=m+1;
    }
    if(ans<ans1) printf("%lld\n",ans1-ans);
    else
    {
        if(!sum) puts("0");
        else puts("1");
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值